# include <sys/time.h>
# include <sys/resource.h>

typedef struct {
  long s, us;
} timing;

long
TIMER(timing *T)
{
  struct rusage r;
  struct timeval t;
  long delay;

  getrusage(0,&r); t = r.ru_utime;
  delay = 1000000 * (t.tv_sec - T->s) + (t.tv_usec - T->us);
  T->us = t.tv_usec;
  T->s  = t.tv_sec; return delay;
}
long delay=0;
timing Timing;

#define TIME(MACHINE) \
do { \
  TIMER(&Timing);\
  MACHINE; \
  delay+=TIMER(&Timing);\
} while(0)

void
display_time(FILE* fout)
{
  fprintf(fout,"time: %ld s %ld ms\n",delay/1000000,(delay/1000)%1000);
}
