inline static long max(long a, long b) { return (a>b)?a:b; }
inline static long min(long a, long b) { return (a<b)?a:b; }

static inline void
xmpn_copy(mp_ptr x, const mp_srcptr y, mp_size_t n)
{
  while (--n >= 0) x[n]=y[n];
}

static inline void
xmpn_zero(mp_ptr x, mp_size_t n)
{
  while (--n >= 0) x[n]=0;
}

static inline void
xmpn_com(mp_ptr x, mp_size_t n)
{
  while (--n >= 0) x[n]=~x[n];
}

static inline int
xmpn_is_zero(mp_srcptr x, mp_size_t n)
{
  while (--n >= 0) if (x[n]) return 0;
  return 1;
}

static inline int
xmpn_is_one(mp_srcptr x, mp_size_t n)
{
  if (x[0]!=1) return 0;
  return xmpn_is_zero(x+1,n-1);
}

static inline mp_size_t
xmpn_normalize(mp_srcptr x, mp_size_t n)
{
  while ( !x[n-1] ) n--;
  return n;
}

