#! /usr/bin/perl -w
use mp822;
mp822::load \%func;
open TMPL,"< doc.tmpl";
open TEX,"> doc.tex";
while(<TMPL>)
{
  m,^%@([A-Za-z/]+)$, or do {print TEX; next;};
  my $sec=$1; chomp $sec;
  my $desc="";
  for (sort grep {defined($func{$_}->{'section'}) && $func{$_}->{'section'} eq $sec} keys %func)
  {
    die "Missing description for function $_" unless (defined($func{$_}->{'desc'}));
    if ($desc ne $func{$_}->{'desc'})
    {
      print TEX "$desc\n";
      $desc=$func{$_}->{'desc'};
    }
    die "Missing prototype for function $_" unless defined($func{$_}->{'proto'});
    print TEX "\\begin{verbatim}\n$func{$_}->{'proto'}\n\\end{verbatim}\n";
  }
  print TEX "$desc\n";
}

for $sec ("mpff","mpffn")
{
  open INCLUDE,"> include/${sec}_func.h";
  print INCLUDE "/*Autogenerated*/\n"; 
  for (sort map {$_->{'proto'}} 
               grep {defined($_->{'section'}) && $_->{'section'} =~ m{^$sec/}} 
                   values %func)
  {
    print INCLUDE "$_;\n";
  }
  close INCLUDE;
}
