#include "mpffn.h"
#include "xmpn.h"

void mpffn_add_ui(mp_ptr r, mp_srcptr x, unsigned long y, const mpffn_field *ff)
{
  mp_limb_t p=ff->p[0];
  xmpn_copy(r+1,x+1,ff->size_elt-1);
  r[0] = x[0]+y;
  if ( r[0] >= p )
    r[0]-=p;
}

void mpffn_sub_ui(mp_ptr r, mp_srcptr x, unsigned long y, const mpffn_field *ff){
  mp_limb_t p=ff->p[0];
  xmpn_copy(r+1,x+1,ff->size_elt-1);
  r[0] = x[0]+p-y;
  if ( r[0] >= p )
    r[0]-=p;
}

void mpffn_pol_neg(mp_ptr r, mp_srcptr x, mp_size_t lt, const mpffn_field *ff)
{
  long i;
  for(i=0; i<lt; i++, x++, r++)
  { 
    if (x[0])
      r[0] = ff->p[0] - x[0];
    else 
      r[0] = 0;
  }
}
