#include "mpffn.h"
#include "mpffn_priv.h"
#include "xmpn.h"

void mpffn_canon_1(mp_ptr r, mp_srcptr x, const mpffn_field *ff)
{
  long i;
  for(i=0; i<ff->lt; i++, x+=ff->lp, r+=ff->lp)
  { 
    if (mpn_cmp(x,ff->p,ff->lp)>=0)
      mpn_sub_n(r,x,ff->p,ff->lp);
    else if (r!=x)
      xmpn_copy(r,x,ff->lp);
  }
}

/*
@function: mpffn_canon:
@section: private
@temp: canon1=ff->lp
       canon2=2*ff->size_elt
*/

void mpffn_canon(mp_ptr r, mp_srcptr x, const mpffn_field *ff)
{
  long i;
  mp_ptr q=ff->tmp->canon1;
  for(i=0; i<ff->lt; i++, x+=ff->lp, r+=ff->lp)
    mpn_tdiv_qr(q,r,0,x,ff->lp,ff->p,ff->size_p);
}

/*
@function: mpffn_pol_canon:
@temp: canon1=ff->lp
*/

void mpffn_pol_canon(mp_ptr r, mp_srcptr x, mp_size_t lt, const mpffn_field *ff)
{
  long i;
  mp_ptr q=ff->tmp->canon1;
  for(i=0; i<lt; i++, x+=ff->lp, r+=ff->lp)
    mpn_tdiv_qr(q,r,0,x,ff->lp,ff->p,ff->size_p);
}
