#include <stdio.h>
#include <stdlib.h>

/*
@function: mpffn_error_hook
@section: mpffn/error
@proto: void (*mpffn_error_hook)(const char *s)
@desc: If defined, this hook is called by mpffn\_error.
*/

void (*mpffn_error_hook)(const char *s)=NULL;

/*
@function: mpffn_error
@section: mpffn/error
@proto: void mpffn_error(const char *s)
@desc: Output s to \textit{stderr} and abort. 
This behaviour can be overrided by setting mpffn\_error\_hook.
This function is called each time a non 1/0 error occurs inside
the library.
*/

void
mpffn_error(const char *s)
{
  if (mpffn_error_hook)
    (*mpffn_error_hook)(s);
  fprintf(stderr,"%s\n",s);
  abort();
}
