#include "mpffn.h"
#include "mpffn_priv.h"
#include "xmpn.h"

/*
@function: mpffn_length
@section: mpffn/private
@proto: mp_size_t mpffn_length(mp_srcptr x, const mpffn_field *ff)
@desc: return one plus the degree of the underlying polynomial of $x$.
*/

mp_size_t mpffn_length(mp_srcptr x, const mpffn_field *ff)
{
  mp_size_t i;
  x+=ff->impl->leader;
  for (i=ff->lt;i && *x==0; i--)
    x--;
  return i;
}

/*
@function: mpffn_pol_length
@section: mpffn/pol
@proto: mp_size_t mpffn_pol_length(mp_srcptr x, mp_size_t lt, const mpffn_field *ff)
@desc: return one plus the degree of the polynomial of $\{x,lt\}$.
*/

mp_size_t mpffn_pol_length(mp_srcptr x, mp_size_t lt, const mpffn_field *ff)
{
  mp_size_t i;
  x += lt-1;
  for (i=lt;i && *x==0; i--)
    x--;
  return i;
}
