#include "mpffn.h"
#include "mpffn_priv.h"
#include "xmpn.h"

/*
@function: mpffn_pol_recip
@section: mpffn/pol
@proto: void mpffn_pol_recip(mp_ptr r, mp_srcptr x, mp_size_t l, const mpffn_field *ff)
@temp: recip=ff->size_elt
@desc: Set $\{r,l\}$ to $\{x,l\}$ written backward: If $P=\{x,l\}$, set
$\{r,l\}$ to $X^{l}P(1/X)$.
*/

void mpffn_pol_recip(mp_ptr r, mp_srcptr x, mp_size_t l, const mpffn_field *ff)
{
  long i;
  mp_ptr rr=ff->tmp->recip;
  x+=(l-1)*ff->lp;
  for(i=0;i<l;i++,rr+=ff->lp,x-=ff->lp)
    xmpn_copy(rr,x,ff->lp);
  mpffn_pol_copy(r,ff->tmp->recip,l,ff); 
}
