#include "mpffn.h"
#include "mpffn_priv.h"
#include "xmpn.h"

/* Destroy x, set r= x % ff->pol
 * l = lg(x) */
void mpffn_red(mp_ptr r, mp_ptr x, mp_size_t l, const mpffn_field *ff)
{
  mp_ptr q=ff->tmp->red1;
  mp_ptr ri;
  long i;
  mpn_tdiv_qr(q,x,0,x,l,ff->pol,ff->size_pol); /*z=xy%pol*/
  for(i=ff->lt, ri=r; i; i--, ri++, x++)
  {
    if (x[0]&(1<<(mp_bits_per_limb-1)))
    {
      x[0]=(~x[0])+1;
      mpn_add_1(x+1,x+1,i,1);
      ri[0] = x[0]%ff->p[0];
      if (ri[0]!=0)
        ri[0] = ff->p[0]-ri[0];
    }
    else
      ri[0] = x[0]%ff->p[0];
  }
  if (x[0]!=0)
    mpffn_sub(r,r,ff->pol,ff);
}
