#include "mpffn.h"
#include "mpffn_priv.h"
#include "xmpn.h"

/*
@function: mpffn_red
@temp: red1=ff->size_sqr
*/

void mpffn_red(mp_ptr r, mp_ptr x, mp_size_t l, const mpffn_field *ff)
{
  mp_ptr red1=ff->tmp->red1;
  mp_srcptr mg=ff->impl->mg;
  long lead=ff->impl->leader;
  long lt=ff->lt;
  long ld=l-lt+1;
  if (l<=lt)
  {
    mpffn_copy(r,x,ff);
    return;
  }
  mpffn_pol_recip(red1,x+lead,ld,ff);        /* z = rec(x)*/
  mpffn_pol_mul(red1,red1,ld,mg,ld,ff);      /* z = rec(x) * mg */
  mpffn_pol_recip(red1,red1,ld,ff);          /* z = rec (rec(x) * mg) */
  mpffn_pol_mul(red1,red1,ld,ff->pol,lt,ff); /* z *= pol */
  mpffn_sub(r,x,red1,ff);                    /* r  = x - z */
}
