#include "mpffn.h"
#include "mpffn_priv.h"
#include "xmpn.h"

/* Destroy x, set r= x % ff->pol
 * l = lg(x) */
void mpffn_red(mp_ptr r, mp_ptr x, mp_size_t l, const mpffn_field *ff)
{
  mp_ptr q=ff->tmp->red1;
  mp_ptr ri;
  long i;
  mpn_tdiv_qr(q,x,0,x,l*ff->lp,ff->pol,ff->size_pol); /*z=xy%pol*/
  for(i=ff->lt, ri=r; i; i--, ri+=ff->lp, x+=ff->lp)
  {
    xmpn_zero(ri,ff->lp);
    if (x[ff->lp-1]&(1<<(mp_bits_per_limb-1)))
    {
      xmpn_com(x,ff->lp);
      mpn_add_1(x,x,ff->lp,1);
      mpn_add_1(x+ff->lp,x+ff->lp,ff->lp*i,1);
      mpn_tdiv_qr(q,ri,0,x,ff->lp,ff->p,ff->size_p);
      if (!xmpn_is_zero(ri,ff->lp))
        mpn_sub_n(ri,ff->p,ri,ff->lp);
    }
    else
      mpn_tdiv_qr(q,ri,0,x,ff->lp,ff->p,ff->size_p);
  }
  if (!xmpn_is_zero(x,ff->lp))
    mpffn_sub(r,r,ff->pol,ff);
}
